/*
 * This File is one of the examples from Java Object Oriented Programming
 * Do not reproduce this code for others or use it in a commercial setting without prior permission from the author.
 */

package productsFinal;

import java.text.NumberFormat;

/**
 *
 * @author Matthew Gregory
 * @website www.matthewgregory-author.com.au
 *
 */
public abstract class Item {
    protected final String name;
    protected Description description = new Description();
    protected double price;
    
    public Item(String name) {
        this.name = name;
    }
    
    public void enterDescription(String comment) {
        this.description = new Description(comment);
    }

    public String getName() {
        return name;
    }

    protected String getDescription() {
        return description.comments;
    }

    public abstract String getPrice();

    public abstract void setPrice(double price);
    
    //This method will be used whenever anyone want to print out the details of a product.
    public void printProduct() {
        //Print out Name, Description and Price
        System.out.println("Name: " + getName());
        System.out.println("Description: " + getDescription());
        System.out.println("Price: " + getPrice());
    }
}
